// DbMonClasses.h

#pragma once

using namespace System;

namespace DbMonClass
{

	public __gc class TraceMonitorEventArgs {
	private:
		int _processId;
		System::String *_message;

	public:
		TraceMonitorEventArgs(int processId, char *message) {
			_processId = processId;
			_message = System::Runtime::InteropServices::Marshal::PtrToStringAnsi(message);
		}

		__property System::String *get_Message() { return _message; };
		__property int get_ProcessId() { return _processId; }
	};
	
	public __delegate void TraceMonitorEventHandler(System::Object *sender, TraceMonitorEventArgs *e);

	public __gc class DbMon
	{
	public:
		System::Boolean _active;
		void EventThreadRoutine();
		__event TraceMonitorEventHandler *TraceMonitorMessage;
	};
}
